-- code by Copyright (c) 2012 Enrique García Cota

function getLiangBarskyIndices(l,t,w,h, x1,y1,x2,y2) -- creates a Liang-Barsky parsed line
  local t0, t1 = 0, 1
  local dx, dy = x2-x1, y2-y1
  local p, q, r

  for side = 1,4 do
    if     side == 1 then p,q = -dx, x1 - l
    elseif side == 2 then p,q =  dx, l + w - x1
    elseif side == 3 then p,q = -dy, y1 - t
    else                  p,q =  dy, t + h - y1
    end

    if p == 0 then
      if q < 0 then return nil end
    else
      r = q / p
      if p < 0 then
        if     r > t1 then return nil
        elseif r > t0 then t0 = r
        end
      else -- p > 0
        if     r < t0 then return nil
        elseif r < t1 then t1 = r
        end
      end
    end
  end
  return t0, t1
end
local function sortByT0(a,b) return a.t0 < b.t0 end

 -- casts a collision line.
function getCollisionLine(objects, x1,y1,x2,y2)
  local collisions, len = {},0
  for i=1, #objects do
    local obj = objects[i]
    local t0,_ = getLiangBarskyIndices(obj.l, obj.t, obj.w, obj.h, x1,y1,x2,y2)
    if t0 then
      len = len + 1
      collisions[len] = {obj=obj, t0=t0}
    end
  end

  table.sort(collisions, sortByT0)
  local result = {}
  for i=1,len do result[i] = collisions[i].obj end
  return result
end

function getObjectsInRoom()
  
end