Door = {}
Door.__index = Door

function Door.create(x,y,n,prop)
	local self = {}
	setmetatable(self, Door)

	self.x = x
	self.y = y
  self.w = 32
  self.h = 32
	self.name = n
	self.dest = prop.dest
  self.isOn = false

	return self
end

function Door:openDoor(pl)
  local d = self.dest
  -- print ("the destination is "..d)
  
  if self.isOn then
    if not (d == "noone") then
      for i,v in ipairs(map.doors) do
        if v.name == d then
          -- print("ipairs stumbled on "..v.name..". They are same.")
          pl.x = v.x+32
          pl.y = v.y
        end
      end
    end
  end
  
  self.isOn = false
  
end

function Door:draw()
  lg.drawq(dimage, dquad, self.x, self.y)
end

function Door:collidePlayer(pl)
    local cx1, cx2 = self.x - self.w / 2, self.x + self.w / 2 - 1
    local cy1, cy2 = self.y - self.h / 2, self.y + self.h / 2 - 1
    local px1, px2 = pl.x - pl.w / 2, pl.x + pl.w / 2 - 1
    local py1, py2 = pl.y - pl.h / 2, pl.y + pl.h / 2 - 1
   
    return ((cx2 >= px1) and (cx1 <= px2) and (cy2 >= py1) and (cy1 <= py2))
end