Thug = 	{}
Thug.__index = Thug

function Thug.create(x,y)
  print("this y = "..y)
  local self = {}
  setmetatable(self, Thug)
  
  self.alive = true
	self.x = x
	self.y = y
  self.x_vel = 100
  self.y_vel = 0
  self.initx = x
  self.inity = y
  self.time = 0
  self.dir = -1
  self.jump = 40
  self.state = 1 -- 0 = idle, 1 = patrol, 2 = follow, 3 = attack
	self.h = 32
	self.w = 16
	self.lb = 64 -- 32*2
	self.rb = 48 -- 32*1.5
  self.towards = false
  
  print("thug made")
  return self
end

function Thug:update(dt)
  self.time = self.time + dt*2
  local thex = math.floor(self.x)
  local printtowards = ""
  
  if self.alive then
		local leftBound = self.initx - self.lb
		local rightBound = self.initx + self.rb
    
    if (self.state == 0) then
    if self.x_vel > 0 then
      thex = rightBound
    elseif self.x_vel < 0 then
      thex = leftBound
    end
      if self.time >= math.pi then
        self.time = 0
        self.state = 1
      end
		elseif (self.state == 1) then
			if (thex < leftBound) then
        self.x_vel = 100
        self.time = 0
        self.state = 0
      end
			if thex > rightBound then
        self.x_vel = -100
        self.time = 0
        self.state = 0
      end
      self.x = thex + (self.x_vel*dt)
      self:getPlayerFacing(p)
      --if (self:isPlayerSeen(self.x, self.y, p.x, p.y)) then
        --print ("ENEMY SPOTTED")
      --end
    --elseif (self.state == 2) then
		end

		if (self.state == 0) then
			tstand:update(dt)
		elseif (self.state == 1) and (self.x_vel >= 0) then
			twalkr:update(dt)
		elseif (self.state == 1) and (self.x_vel <= 0) then
			twalkl:update(dt)
		end
		
    if self.towards then
      printtowards = "YES"
    else
      printtowards = "NO"
    end
      
    print("x = "..thex..", x_vel = "..self.x_vel..", rightBound = "..rightBound..", time passed = "..self.time..", state = "..self.state..", is facing player? = "..printtowards)
	end
end

function Thug:draw()
  if self.alive then
    if (self.state == 0) then
      tstand:draw(timage, (self.x-16), (self.y))
    elseif (self.state == 1) and (self.x_vel >= 0) then
      twalkr:draw(timage, (self.x-16), (self.y))
    elseif (self.state == 1) and (self.x_vel <= 0) then
      twalkl:draw(timage, (self.x-16), (self.y))
    end
  end
end

function Thug:isPlayerSeen(x1,y1,x2,y2)
  local seenObjects = getCollisionLine(getObjectsInRoom(), x1,y1,x2,y2)
  for obj in ipairs(seenObjects) do
    if obj == p then return true end
    if obj.isOpaque then return false
    -- else continue evaluating seenObjects
    end
  end
  return false -- the player was not even on seenObjects
end
function Thug:getPlayerFacing(pl)
  local facing = false
  if (self.x_vel < 0) and (pl.x < self.x) then
    facing = true
  elseif (self.x_vel < 0) and (pl.x > self.x) then
    facing = false
  elseif (self.x_vel > 0) and (pl.x > self.x) then
    facing = true
  elseif (self.x_vel > 0) and (pl.x < self.x) then
    facing = false
  end
  self.towards = facing
end
