function pCtrl(dt)
  if (p.lives > 0) then
    --player controls for moving left or right
    if love.keyboard.isDown("left") then
      p:left()
    elseif love.keyboard.isDown("right") then
      p:right()
    else
      p:stop()
    end
    
    --player controls for walking/running
    if love.keyboard.isDown("lshift") then
      p:run()
    else
      p:walk()
    end
    
    --player controls for jumping
    if love.keyboard.isDown(" ") then
      p:jump()
    else
      p:jumpLetGo()
    end
    p:update(dt, world.gravity)
  end
end

function pAnimationUpdate(dt)
      if (p.state == "stand") then
        pstand:update(dt)
      elseif (p.state == "right") and (p.speed_status == "run") then
        prunr:update(dt)
      elseif (p.state == "left") and (p.speed_status == "run") then
        prunl:update(dt)
      elseif (p.state == "right") and (p.speed_status == "walk") then
        pwalkr:update(dt)
      elseif (p.state == "left") and (p.speed_status == "walk") then
        pwalkl:update(dt)
      elseif (p.state == "jump") and (p.x_vel >= 0) then
        pjumpr:update(dt)
      elseif (p.state == "jump") and (p.x_vel < 0) then
        pjumpl:update(dt)
      elseif (p.state == "fall") and (p.x_vel >= 0) then
        pfallr:update(dt)
      elseif (p.state == "fall") and (p.x_vel < 0) then
        pfalll:update(dt)
      end
end

function pDeathUpdate(dt)
    if (p.state == "death") and (p.lives >= 1) then
      p.x = map.startx
      p.y = map.starty
      p.x_vel = 0
      p.y_vel = 0
      p.state = "stand"
      p.lives = p.lives - 1
    elseif (p.lives == 0) then
      isDead = true
    end
end